unit SumForm2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label2: TLabel;
    Button2: TButton;
    Label3: TLabel;
    Button3: TButton;
    Label4: TLabel;
    Button4: TButton;
    Label5: TLabel;
    Label6: TLabel;
    Memo1: TMemo;
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormActivate(Sender: TObject);
    procedure ButtonsClick(Sender: TObject;Num:Integer);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    Sum,Average,Min,Max:Real;
    br:integer;
  public
    procedure Calculate(X:String);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Calculate(X: String);
var r:Real;
begin
   r:=strtofloat(X);
   inc(br); Label6.Caption:='Count of selected numbers:'+inttostr(br);
   if br=1 then begin Min:=r;Max:=r end;
   Sum:=Sum+r;
   if Min>r then Min:=r;
   if Max<r then Max:=r;
   Average:=Sum/br
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  If ord(Key)=VK_Return then
  begin
    ListBox1.Items.Add(Edit1.Text);
    Edit1.Text:='';
    Label1.Caption:='Input next number:'
  end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
    Edit1.SetFocus;
    ListBox1.MultiSelect:=True;
end;

procedure TForm1.ButtonsClick(Sender: TObject;Num:Integer);
var i:integer;
begin
    Sum:=0;Average:=0;br:=0;
    for i:=0 to ListBox1.Items.Count-1 do
    if ListBox1.Selected[i] then Calculate(ListBox1.Items[i]);
    if br>0 then Case Num of
       1:Label2.Caption:='The sum is: '+floattostr(Sum);
       2:Label3.Caption:='The average is: '
        +floattostrF(Average,ffFixed,12,5);
       3:Label4.Caption:='The minimus is: '+floattostr(Min);
       4:Label5.Caption:='The maximum is: '+floattostr(Max)
    End else
    Case Num of
       1:Label2.Caption:='You did not marked the numbers!';
       2:Label3.Caption:='You did not marked the numbers!';
       3:Label4.Caption:='You did not marked the numbers!';
       4:Label5.Caption:='You did not marked the numbers!'
    End;
    Edit1.SetFocus;
end;

procedure TForm1.Button1Click(Sender: TObject);
  begin ButtonsClick(Sender,1) end;
procedure TForm1.Button2Click(Sender: TObject);
  begin ButtonsClick(Sender,2) end;
procedure TForm1.Button3Click(Sender: TObject);
  begin ButtonsClick(Sender,3) end;
procedure TForm1.Button4Click(Sender: TObject);
  begin ButtonsClick(Sender,4) end;

end.

