unit AutoForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ExtCtrls;

type
  Auto=record
    Marka:String[15];
    GodPr,Cena:Integer
  end;
  AutoFile=File of Auto;
  TForm1 = class(TForm)
    LE2: TLabeledEdit;
    Combo: TComboBox;
    LE1: TLabeledEdit;
    Label1: TLabel;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    LB: TListBox;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    procedure N1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure LBClick(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N13Click(Sender: TObject);
    procedure N14Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    private
    n:integer;//Total number cars
    f:AutoFile;a:Auto;
    procedure AddRecord;
    procedure DeleteRecord(i:integer);
    procedure ModifyRecord;
    function ConvToString(a:auto):string;//Convert int String
  end;

var
  Form1: TForm1;
  i:integer=0;

implementation
{$R *.dfm}

function TForm1.ConvToString(a: auto): string;
var s:string[15];
begin
   s:=a.Marka+'                            ';
   Result:=s+'|'+Inttostr(a.GodPr)+' year | '+
           Inttostr(a.Cena)+' E'

end;

procedure TForm1.AddRecord;
begin
   Seek(f,n);
   a.Marka:=Combo.Text;
   a.Cena:=strtoint(LE1.Text);
   a.GodPr:=strtoint(LE2.Text);
   Write(f,a);
   LB.Items.Add(ConvToString(a));
   inc(n);
   i:=n-1;
   LB.ItemIndex:=i;
end;

procedure TForm1.DeleteRecord;
var j:integer;
begin
   if n=0 then exit;
   Seek(f,i);
   read(f,a);
   if messagedlg('Do you want to delete it '+ConvToString(a)+' ? Yes/No :',
      mtWarning,[mbYes,MbNo],0)=mrYes then
      begin
         for j:=i+1 to n-1 do
         begin seek(f,j);read(f,a);
               seek(f,j-1);write(f,a);
         end;
         n:=n-1;
         seek(f,n);
         truncate(f);
         LB.Items.Delete(i);
         if i>=n then i:=i-1;
         LB.ItemIndex:=i;
         if n>0 then LBClick(LB) else
         begin
            Combo.Text:='';
            LE1.Text:='';
            LE2.Text:='';
         end;
         showmessage('Deleted!');
      end;
end;

procedure TForm1.ModifyRecord;
begin
   a.Marka:=Combo.Text;
   a.Cena:=strtoint(LE1.Text);
   a.GodPr:=strtoint(LE2.Text);
   Seek(f,i);
   write(f,a);
   LB.Items[i]:=ConvToString(a);
end;

procedure TForm1.N1Click(Sender: TObject);
begin AddRecord end;

procedure TForm1.N2Click(Sender: TObject);
begin ModifyRecord end;

procedure TForm1.N3Click(Sender: TObject);
begin DeleteRecord(i) end;


procedure TForm1.N6Click(Sender: TObject);
var s:string; j:integer;
begin
   s:=Combo.Text;
   for j:=i+1 to n-1 do
   if pos(s,LB.Items[j])>0 then
   begin
     LB.ItemIndex:=j;
     i:=j;
     break;
   end
end;

procedure TForm1.N9Click(Sender: TObject);
var ind,i,j:integer;a,min:auto;
begin
   for i:=0 to n-2 do
   begin
      ind:=i;seek(f,i);read(f,min);
      for j:=i+1 to n-1 do begin
         seek(f,j);read(f,a);
      if a.marka<min.marka then begin min:=a;ind:=j end;
      end{for j};
      if ind<>i then
      begin
         seek(f,i);read(f,a);
         seek(f,ind);write(f,a);
         seek(f,i);write(f,min)
      end;
      LB.Items[i]:=ConvToString(min);
   end{for i};
   LB.Items[n-1]:=ConvToString(a);
   LB.Itemindex:=n-1;  LBClick(LB);
   showmessage('The cars are sorted by Make!');
end{sort};

procedure TForm1.N13Click(Sender: TObject);
var min:integer;
begin
   Seek(f,0); min:=maxint;
   while not eof(f) do
   begin
     read(f,a);
     if min>a.Cena then min:=a.Cena
   end;
   showmessage('The mininal price is '+inttostr(min)+' E');
end;

procedure TForm1.N14Click(Sender: TObject);
var sr:integer;  s:string;
begin
   Seek(f,0); sr:=0;
   while not eof(f) do
   begin
     read(f,a);
     sr:=sr+a.Cena
   end;
   str(sr/n:0:2,s);
   showmessage('The average price is '+s+' E');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   AssignFile(f,'Auto.dat');
   if FileExists('Auto.dat') then reset(f) else rewrite(f);
   n:=FileSize(f);
   while not eof(f) do
   begin
     read(f,a);
     LB.Items.Add(ConvToString(a))
   end;
   LB.ItemIndex:=i;
end;

procedure TForm1.FormClose;
begin closefile(f) end;

procedure TForm1.LBClick(Sender: TObject);
begin
  i:=LB.ItemIndex;
  Seek(f,i);
  read(f,a);
  Combo.Text:=a.Marka;
  LE1.Text:=inttostr(a.Cena);
  LE2.Text:=inttostr(a.GodPr);
end;

end.
