unit DictForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, StdCtrls;

type
  TForm1 = class(TForm)
    Dict: TListBox;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Button3: TButton;
    Label1: TLabel;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure DictClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  end;

var
  Form1: TForm1;
const t:array[1..5] of string=
('Infinitiv:',
 'Translation:',
 'Present:',
 'Imperfect:',
 'Participle:');
implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
 begin Dict.Items.LoadFromFile('GV.txt') end;

procedure TForm1.Button2Click(Sender: TObject);
  begin Dict.Items.SaveToFile('GV.txt') end;

procedure TForm1.DictClick(Sender: TObject);
 var s:string;j,i:integer;
begin
    Edit1.Text:=Dict.Items[Dict.Itemindex];
    s:= Edit1.Text;i:=0;
    repeat
     inc(i);
     j:=pos('|',s);
     if j>0 then
     begin
       Memo1.Lines.Add(t[i]+copy(s,1,j-1));
       delete(s,1,j)
     end
    until j=0;
    Memo1.Lines.Add(t[i]+s);
    Memo1.Lines.Add('___________________________');
    Memo1.Lines.Add('   ');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  with Dict do
    Items[Itemindex]:=Edit1.Text;
end;



end.
